/*
 * Demonstration program for file I/O
 * CSE 142 Au99 11/30/99  Linda Shapiro
 *
 * The input database file contains records with
 * name, ssn, and age in the following format:
 *
 *	nnnnnnnnnnnnnnnnnnnnsssssssss yy
 *
 * The name is 20 characters, ssn is 9 characters, and age yy is a
 * regular integer.  Notice that the program reads and writes single
 * characters, including newlines.  It works under Windows (VC++ 6.0)
 * and Unix, but may not be portable to other systems.  It also stores
 * the input in simple arrays, and does not create '\0'-terminated
 * C-style strings.
 *
 * Read input file db_file.txt and write to result_file.txt the names
 * and ssn's from all records with age > 20.
 *
 * In the SQL database language, this could be done with one statement:
 *
 *		SELECT NAME, SSN
 *		FROM DB_FILE
 *		WHERE AGE > 20;
 */

#define NAME_LENGTH 20
#define SSN_LENGTH   9
#define AGE_CUTOFF  20

#include <stdio.h>
#include <stdlib.h>

int main(void) {
	
	FILE *inp, *outp;		/* input and output files */
	char name[NAME_LENGTH], /* name and ssn */
		 ssn[SSN_LENGTH];
	int age;				/* age */
	char ch;
	int j;
	
	/* open files */
	inp = fopen("db_file.txt", "r");
	outp = fopen("result_file.txt", "w");
	
	/* repeat until attempt to read new name hits EOF */
	while (fscanf(inp, "%c", &name[0]) != EOF) {
		
		/* read rest of name, ssn, and age */
		for (j = 1; j < NAME_LENGTH; j++) 
			fscanf(inp, "%c", &name[j]);
		for (j = 0; j < SSN_LENGTH; j++) 
			fscanf(inp, "%c", &ssn[j]);
		fscanf(inp, "%d", &age);
		
		/* skip past end-of-line character */
		fscanf(inp, "%c", &ch);

		/* print name, ssn, and newline if age > minimum */
		if (age > AGE_CUTOFF) {
			for (j = 0; j< NAME_LENGTH; j++) 
				fprintf(outp, "%c", name[j]);
			for (j = 0; j < SSN_LENGTH; j++) 
				fprintf(outp, "%c", ssn[j]);
			fprintf(outp, "\n");
		}
	}

	/* close files and terminate */
	fclose(inp);
	fclose(outp);
	return(0);
} 
